-- pre auto-update queries can be found At revision 169.
-- this file is parsed by manqod-server on startup, queries will be auto applied on the databases
-- format: comments start with --, one query per version
-- query; -- version_number
-- version_number will be inserted automatically into db_version by manqod_server

-- adding the database version table, apply i by hand
create table if not exists db_version (`version` float, `utime` timestamp default current_timestamp);

-- first database version, apply it by hand
insert into db_version set version=1; --1

ALTER TABLE  `gtkprintitems` ADD  `text_alignment` VARCHAR( 6 ) NOT NULL DEFAULT  'left'; --2

ALTER TABLE  `users` drop  `autologin`; --3

ALTER TABLE  `tables` CHANGE  `name`  `name` CHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL; -- 4

ALTER TABLE  `history` CHANGE  `list_id`  `base` VARCHAR( 100 ) NOT NULL; --5

ALTER TABLE  `users` ADD  `email` TEXT NOT NULL ; --6

INSERT INTO  `modules` (`id` ,`modname`)VALUES (NULL ,  'help'); --7

DROP TABLE IF EXISTS `help`; --8

CREATE TABLE  `help_items` (`index` VARCHAR( 100 ) NOT NULL ,`description` TEXT NOT NULL ,PRIMARY KEY (  `index` )) ENGINE = MYISAM; --9
CREATE TABLE  `help_formats` (`name` VARCHAR( 100 ) NOT NULL ,`format_dump` TEXT NOT NULL ,PRIMARY KEY (  `name` )) ENGINE = MYISAM; --10

DROP TABLE IF EXISTS `messages`; --11
CREATE TABLE  `messages` (`id` BIGINT NOT NULL AUTO_INCREMENT,`date` datetime, `sender` CHAR( 12 ) NOT NULL ,`recipient` CHAR( 12 ) NOT NULL ,`subject` TEXT NOT NULL ,`body` TEXT NOT NULL ,`state` CHAR( 1 ) NOT NULL ,PRIMARY KEY (  `id` )) ENGINE = MYISAM; --12
ALTER TABLE `todo` ADD `comment` TEXT NOT NULL AFTER `todo`; --13

CREATE TABLE  `cronjobs` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,`moditems_id` INT NOT NULL ,`cron` VARCHAR( 32 ) NOT NULL , `command` TEXT NOT NULL ) ENGINE = MYISAM; --14

