#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

module Cron
	class CronJob
		def initialize(cron_id,cron,moditems_id,command,drbdb)
			@cron_id=cron_id
			@cron=cron
			@moditems_id=moditems_id
			@command=command
			@drbdb=drbdb
			@scheduler=@drbdb.scheduler
			@job=nil
			
		end
		def register
			@job=@scheduler.cron(@cron) {|job|
				if @drbdb.moditem(@moditems_id) and b=@drbdb.moditem(@moditems_id).getBinding then
					@drbdb.einfo("running ##{@cron_id} @#{@cron} on #{@drbdb.moditem(@moditems_id)}")
					ret=eval(@command, b)
				end
			}
			self
		end
		def unregister
			@job.unschedule if @job
		end
		def to_s
			"CronJob ##{@cron_id}"
		end
	end

	def start_cron
		einfo("starting Cron")
		@scheduler = Rufus::Scheduler.start_new
		@crons=Hash.new
		admin.rows("select * from cronjobs").each{|row|
			@crons[row["id"].to_i]=CronJob.new(row["id"].to_i,row["cron"],row["moditems_id"].to_i,row["command"],self).register;
		}
	end
	attr_reader :scheduler

	def stop_cron
		einfo("stopping Cron")
		@scheduler.stop
	end
	def remove_cron(cron_id)
		edebug("removing cronjob ##{cron_id}")
		if @crons.has_key?(cron_id)
			@crons[cron_id].unregister
			@crons.delete(cron_id)
		end
	end
	def add_cron(cron_id)
		admin.rows("select * from cronjobs where id='#{cron_id}'").each{|row|
			edebug("adding cronjob ##{cron_id} for #{moditem(row["moditems_id"].to_i)}")
			@crons[row["id"].to_i]=CronJob.new(row["id"].to_i,row["cron"],row["moditems_id"].to_i,row["command"],self).register;
		}
	end
	def reset_cron(cron_id)
		remove_cron(cron_id)
		add_cron(cron_id)
	end
end

