#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class ManqodLogger < Logger::Application
	include Singleton

	LEVEL_MAP={
		"DEBUG" => Logger::Severity::DEBUG,
		"INFO"	=> Logger::Severity::INFO,
		"WARN"	=> Logger::Severity::WARN,
		"ERROR"	=> Logger::Severity::ERROR,
		"FATAL"	=> Logger::Severity::FATAL,
		"UNKNOWN"	=> Logger::Severity::UNKNOWN
	}

	@report_address=nil
	attr_reader :report_address

	def set_level(llevel)
		self.level=LEVEL_MAP[llevel]
	end
	def set_report_address(ra)
		@report_address=ra
	end
end

