#this file is part of manqod
#manqod is distributed under the CDDL licence
#the owner of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class DrbImages
	include Eprint
	include DRbUndumped
	def initialize(drbdb)
		@drbdb=drbdb
		@images=Hash.new
	end
	attr_reader :drbdb, :images
	

	def load_all
		@keys=Hash.new
		begin
		drbdb.admin.rows("select * from images").each{|row|
			@images[row["id"].to_i]=row
			@drbdb.cache.set("im[#{row["id"]}]",row)
			@keys[row["id"].to_i]="im[#{row["id"]}]"
		}
		rescue => err
		end
		@drbdb.cache.set("imkeys",@keys)
		einfo("#{@images.size} images")
		self
	end
	def get_image(image_id)
		@images[image_id.to_i]
	end
	def keys
		@images.keys
	end
	def to_s
		"Images of #{drbdb}"
	end
end

